"use strict";
(() => {
var exports = {};
exports.id = 1710;
exports.ids = [1710];
exports.modules = {

/***/ 6517:
/***/ ((module) => {

module.exports = require("lodash");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 2081:
/***/ ((module) => {

module.exports = require("child_process");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 6520:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1017);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4432);
/* harmony import */ var _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6517);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_2__);
// @ts-check
const { execSync  } = __webpack_require__(2081);
const fs = __webpack_require__(7147);



/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        success: false,
        msg: "Wrong Method"
    });
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ const user = await _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1___default()(req);
    if (!user?.logged_in_status) {
        return res.json({
            success: false,
            log: "No Logs"
        });
    }
    ////////////////////////////////////////
    ////////////////////////////////////////
    ////////////////////////////////////////
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ try {
        const envPath = path__WEBPACK_IMPORTED_MODULE_0___default().join(process.cwd(), ".env");
        const envContent = fs.readFileSync(envPath, "utf-8");
        const envRegex = new RegExp(`${lodash__WEBPACK_IMPORTED_MODULE_2___default().escapeRegExp(req.body.key)}=.*`);
        const envMatch = envContent.match(envRegex);
        const newEnv = envContent.replace(envRegex, `${req.body.key}=${req.body.value}`);
        fs.writeFileSync(envPath, newEnv, "utf-8");
        res.json({
            success: true
        });
    ////////////////////////////////////////
    ////////////////////////////////////////
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        console.log("updating Env error =>", error.message);
        res.json({
            success: false,
            error: error.message
        });
    }
////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [4432], () => (__webpack_exec__(6520)));
module.exports = __webpack_exports__;

})();