"use strict";
(() => {
var exports = {};
exports.id = 5450;
exports.ids = [5450];
exports.modules = {

/***/ 6517:
/***/ ((module) => {

module.exports = require("lodash");

/***/ }),

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 1090:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6517);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(1352);
/* harmony import */ var _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(1311);
/* harmony import */ var _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_4__);
// @ts-check
const fs = __webpack_require__(7147);
////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////





/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * @typedef {object} InfiniteScrollBodyObject
 * @property {string} dbName
 * @property {import("@/package-shared/types").DSQL_TableSchemaType} tableSchema
 * @property {string} tableName
 * @property {number} page
 * @property {boolean} delegated
 * @property {string} [search]
 * @property {string} [searchField]
 */ /**
 * @typedef {object} InfiniteScrollAPIRes
 * @property {boolean} success
 * @property {any[] | null} [data]
 * @property {number} [page]
 */ const BATCH_NO = 20;
/**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        user: null,
        msg: "Registration Failed!"
    });
    /**
     * User Auth
     *
     * @description User Auth
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /** @type {InfiniteScrollBodyObject} */ const body = req.body;
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ try {
        const delegatedUser = await _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_3___default()({
            databaseSlug: body.dbName,
            request: req,
            user: user,
            query: req.query
        });
        const finalUserId = delegatedUser ? delegatedUser?.rootUserId ? delegatedUser.rootUserId : delegatedUser.dbUserId : null;
        if (!finalUserId) throw new Error("User not Found!");
        const dbNameFull = `datasquirel_user_${finalUserId}_${body.dbName}`;
        const tableName = body.tableName;
        const page = body.page;
        const offset = BATCH_NO * page;
        let query = `SELECT * FROM ${tableName}`;
        let queryValues = [];
        if (body.search && body.searchField) {
            query += ` WHERE LOWER(\`${body.searchField.toLowerCase().replace(/ /g, "_")}\`) LIKE ?`;
            queryValues.push(`%${body.search.toLowerCase()}%`);
        }
        query += ` ORDER BY id DESC LIMIT ${BATCH_NO} OFFSET ${offset}`;
        const tableEntries = await _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_4___default()({
            database: dbNameFull,
            queryString: query,
            queryValuesArray: queryValues,
            tableSchema: body.tableSchema
        });
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        /** @type {InfiniteScrollAPIRes} */ const resObject = {
            success: true,
            data: tableEntries,
            page: Number(page) + 1
        };
        res.json(resObject);
    ////////////////////////////////////////
    ////////////////////////////////////////
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
            component: "/api/infiniteScroll/catch-error",
            message: error.message,
            user: user
        });
        res.json({
            success: false,
            data: null
        });
    }
////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,3017,3403,8326,1311,1352], () => (__webpack_exec__(1090)));
module.exports = __webpack_exports__;

})();