"use strict";
exports.id = 3314;
exports.ids = [3314];
exports.modules = {

/***/ 2527:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Z": () => (/* binding */ grabUserSchemaData)
/* harmony export */ });
// @ts-check
const serverError = __webpack_require__(2317);
const fs = __webpack_require__(7147);
const path = __webpack_require__(1017);
/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * ==============================================================================
 * @param {Object} params
 * @param {string | number} params.userId
 * @returns {import("@/package-shared/types").DSQL_DatabaseSchemaType[] | null}
 */ function grabUserSchemaData({ userId  }) {
    try {
        const userSchemaFilePath = path.resolve(process.cwd(), `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${userId}/main.json`);
        const userSchemaData = JSON.parse(fs.readFileSync(userSchemaFilePath, "utf-8"));
        return userSchemaData;
    } catch (/** @type {any} */ error) {
        serverError({
            component: "/functions/backend/grabUserSchemaData",
            message: error.message
        });
        return null;
    }
} /** ****************************************************************************** */  /** ****************************************************************************** */  /** ****************************************************************************** */  /** ****************************************************************************** */  /** ****************************************************************************** */  /** ****************************************************************************** */ 


/***/ })

};
;