"use strict";
(() => {
var exports = {};
exports.id = 8141;
exports.ids = [8141];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 6450:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2224);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4432);
/* harmony import */ var _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1__);
// @ts-check


const fs = __webpack_require__(7147);
/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        success: false,
        msg: "Wrong Method"
    });
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ const user = await _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1___default()(req);
    if (!user?.logged_in_status) {
        return res.json({
            success: false,
            log: "No Logs"
        });
    }
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ const dsqlUser = req.body.user;
    const dsqlUserId = dsqlUser?.id.toString().replace(/[^0-9]/g, "").replace(/\//g, "");
    const userFolder = `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${dsqlUserId}`;
    /** @type {any[]} */ let userData = [];
    /**
     *
     * @param {object} params
     * @param {any[]} params.originArray
     * @param {string} params.rootPath
     */ function grabFolderContent({ originArray , rootPath  }) {
        const folderContent = fs.readdirSync(rootPath);
        for(let i = 0; i < folderContent.length; i++){
            const fileName = folderContent[i];
            if (fileName?.match(/\..{2,5}$/)) {
                originArray.push({
                    name: fileName,
                    type: "file",
                    root: rootPath
                });
            } else {
                const newObject = {
                    name: fileName,
                    type: "folder",
                    root: rootPath,
                    content: []
                };
                grabFolderContent({
                    originArray: newObject.content,
                    rootPath: `${rootPath}/${fileName}`
                });
                originArray.push(newObject);
            }
        }
    }
    grabFolderContent({
        originArray: userData,
        rootPath: userFolder
    });
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    /** @type {any[]} */ const userDatabases = await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`SHOW databases LIKE 'datasquirel_user_${dsqlUser.id}_%'`);
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    res.json({
        success: true,
        data: userData,
        databases: userDatabases.map((db)=>Object.values(db)[0])
    });
////////////////////////////////////////////////
////////////////////////////////////////////////
////////////////////////////////////////////////
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,4432], () => (__webpack_exec__(6450)));
module.exports = __webpack_exports__;

})();