"use strict";
(() => {
var exports = {};
exports.id = 7896;
exports.ids = [7896];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 2081:
/***/ ((module) => {

module.exports = require("child_process");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 2037:
/***/ ((module) => {

module.exports = require("os");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 711:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_exportDb__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4194);
/* harmony import */ var _functions_backend_exportDb__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_exportDb__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_1__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ 

const fs = __webpack_require__(7147);
const path = __webpack_require__(1017);
/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "GET") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_1___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ const { dbName  } = req.query;
    /**
     * Input Validation
     *
     * @description Input Validation
     */ try {
        const schemaPath = path.resolve(String(process.env.DSQL_USER_DB_SCHEMA_PATH), `user-${user.id}/main.json`);
        if (!fs.existsSync(schemaPath)) {
            return res.end();
        }
        /** @type {import("@/package-shared/types").DSQL_DatabaseSchemaType[]} */ const schemaData = JSON.parse(fs.readFileSync(schemaPath, "utf-8"));
        const targetSchema = schemaData.find((schema)=>schema.dbFullName == dbName);
        if (!targetSchema) throw new Error("Database not found!");
        const targetWritePath = path.resolve(process.cwd(), "./.tmp/_tmp.json");
        fs.writeFileSync(targetWritePath, JSON.stringify(targetSchema), "utf-8");
        const fileStream = fs.createReadStream(targetWritePath);
        fileStream.pipe(res);
        fileStream.on("close", ()=>{
            fs.unlinkSync(targetWritePath);
        });
    } catch (error) {
        console.log(error);
        return res.end();
    }
////////////////////////////////////////
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,4194], () => (__webpack_exec__(711)));
module.exports = __webpack_exports__;

})();