// @ts-check
const fs = require("fs");
const grabDist = require("./utils/grabDist");

/**
 * @returns {string | undefined}
 */

/**
 * @type {import('next').NextConfig}
 */
const nextConfig = {
    reactStrictMode: true,
    eslint: {
        ignoreDuringBuilds: true,
    },
    typescript: {
        ignoreBuildErrors: true,
    },
    distDir: grabDist(),
    // async redirects() {
    //     return [
    //         {
    //             source: String(process.env.NEXT_PUBLIC_DSQL_SU_ADMIN_ORIGIN),
    //             destination: "/su",
    //             permanent: false,
    //         },
    //     ];
    // },
};

module.exports = nextConfig;
